//+------------------------------------------------------------------+
//|                                                          RSI.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
 
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_level1 50
#property indicator_color1 Blue
#property indicator_color2 Indigo
#property indicator_color3 Blue
#property indicator_color4 Maroon
//---- input parameters
extern double tf_i_period=60.12; //tf, RSIPeriod
extern double tf2_period2=60.8;  //tf, RSIPeriod
extern double tf3_period3=60.4;  //tf, RSIPeriod
extern double tf4_period4=0;     //tf, RSIPeriod
extern bool teni=true;
extern color color1=Maroon;
extern color color2=Blue;
extern color color3=Indigo;
extern color color4=Blue;
extern int bars=0;
int tf, tf2, tf3, tf4;
int RSIPeriod,RSIPeriod2,RSIPeriod3,RSIPeriod4;
int Lines=1;
int p,x;
//---- buffers
double Rel[];
double Rhi[];
double Rlo[];
double RSI[];
double RSI2[];
double RSI3[];
double RSI4[];//+---------------------------------------------------------------------+
int init()    //|  Custom indicator initialization function                           |
  {           //+---------------------------------------------------------------------+
     p=MathRound(1.0/Point);     tf=MathFloor(tf_i_period); RSIPeriod =pt(tf_i_period);
   if(tf2_period2>0) { Lines=2; tf2=MathFloor(tf2_period2); RSIPeriod2=pt(tf2_period2); }
   if(tf3_period3>0) { Lines=3; tf3=MathFloor(tf3_period3); RSIPeriod3=pt(tf3_period3); }
   if(tf4_period4>0) { Lines=4; tf4=MathFloor(tf4_period4); RSIPeriod4=pt(tf4_period4); }
//---- indicator lines
   IndicatorBuffers(7);
   SetIndexBuffer(6,Rel);
   SetIndexBuffer(5,Rhi);
   SetIndexBuffer(4,Rlo);
   SetIndexBuffer(3,RSI);              SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(2,RSI2); if(Lines>1) SetIndexStyle(2,DRAW_LINE); else SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(1,RSI3); if(Lines>2) SetIndexStyle(1,DRAW_LINE); else SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(0,RSI4); if(Lines>3) SetIndexStyle(0,DRAW_LINE); else SetIndexStyle(0,DRAW_NONE);
//---- name for DataWindow and indicator subwindow label
    string short_name="RSI("+tf+"."+RSIPeriod;
   if(Lines>1) short_name=short_name+" "+tf2+"."+RSIPeriod2;
   if(Lines>2) short_name=short_name+" "+tf3+"."+RSIPeriod3;
   if(Lines>3) short_name=short_name+" "+tf4+"."+RSIPeriod4;
               short_name=short_name+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   x=WindowFind(short_name);
                  return(0);}
   int deinit() { return(0);
  }         //+------------------------------------------------------------+
int start() //|  Relative Strength Index                                   |
  {         //+------------------------------------------------------------+
   int i=0,counted=IndicatorCounted();
   if(bars<1)bars=Bars+MathMax(MathMax(tf,tf2),MathMax(tf3,tf4))/Period()*2;  // 2*TF/curTF (2  TF)
//---- initial zero
   //if(counted<1) while(i<=RSIPeriod) { i++; RSI[bars-i]=0.0;
       //RSI3[bars-i]=0.0; RSI2[bars-i]=0.0; RSI4[bars-i]=0.0; }
              for(i=Bars; i>=0; i--) Rel[i]=pr(Close[i])-pr(Close[i+1]);
     if(teni) for(i=Bars; i>=0; i--) {Rhi[i]=pr(High[i])-pr(Close[i+1]);
                                      Rlo[i]=pr(Low[i])-pr(Close[i+1]);
                                                Rlo[i]=MathMin(Rlo[i],0);
                                                Rhi[i]=MathMax(Rhi[i],0);}
   
              for(i=bars-counted; i>=0; i--)  RSI[i]=rsi(i,RSIPeriod, tf, 0);
   if(Lines>1)for(i=bars-counted; i>=0; i--) RSI2[i]=rsi(i,RSIPeriod2,tf2,0);
   if(Lines>2)for(i=bars-counted; i>=0; i--) RSI3[i]=rsi(i,RSIPeriod3,tf3,0);
   if(Lines>3)for(i=bars-counted; i>=0; i--) RSI4[i]=rsi(i,RSIPeriod4,tf4,0);
   
    if(teni) {for(i=bars-counted; i>=0; i--)
       teni("4",i,rsi(i,RSIPeriod, tf, 1),
                  rsi(i,RSIPeriod, tf, 2),color1);
   if(Lines>1)for(i=bars-counted; i>=0; i--)
       teni("3",i,rsi(i,RSIPeriod2,tf, 1),
                  rsi(i,RSIPeriod2,tf, 2),color2);
   if(Lines>2)for(i=bars-counted; i>=0; i--)
       teni("2",i,rsi(i,RSIPeriod3,tf, 1),
                  rsi(i,RSIPeriod3,tf, 2),color3);
   if(Lines>3)for(i=bars-counted; i>=0; i--)
       teni("1",i,rsi(i,RSIPeriod4,tf, 1),
                  rsi(i,RSIPeriod4,tf, 2),color4);}
   return(0);
  }//+------------------------------------------------------+
//--------------------------------------------------|  RSI  |
double rsi(int shift, int per, int TF, int type) { //+------+
         double pos=0.0,
                neg=0.0, rsi;
         int lim=per, time=Time[shift]; bool last;
       if(TF>0) lim=iBarShift(NULL,0,iTime(NULL,TF,iBS(TF,time)+per))-shift;
                  //iBarShift(curTF)   iBS + per               -shift
       for(int k=0; k<lim; k++)              { //  RSIPeriod 
                int rel=Rel[shift+k];          // 
                
        if(k==0 && type>0) last=true;
                      else last=false;
        if(last){                              //  >0   last   
         if(type>1) rel=Rlo[shift];            // Low-Close[i+1] 
               else rel=Rhi[shift];}           // High-Close[i+1]
               
         if(rel>0) pos+=rel; else neg+=-rel; } // pos+=  neg+=

      if(neg<1) rsi=100.0;
      else rsi=pos/(pos+neg)*100.0;            // rsi
      
   if(type<1 && TF>0)
   if(iTime(NULL,TF,iBS(TF,time))+(TF-Period())*60==time) //     TF
     //Time iBS,   time +   TF - 
   if(ObjectFind("x"+TF+"_"+per+"cls"+time)<0)                 {
    ObjectCreate("x"+TF+"_"+per+"cls"+time,OBJ_TREND,x,time,rsi,time,rsi);
       ObjectSet("x"+TF+"_"+per+"cls"+time,OBJPROP_WIDTH, 2);
       ObjectSet("x"+TF+"_"+per+"cls"+time,OBJPROP_COLOR,White);
       ObjectSet("x"+TF+"_"+per+"cls"+time,OBJPROP_RAY, false);}
    else {
       ObjectSet("x"+TF+"_"+per+"cls"+time,OBJPROP_PRICE1,rsi);
       ObjectSet("x"+TF+"_"+per+"cls"+time,OBJPROP_PRICE2,rsi);}
   return(rsi);                                                       }
//+-------------------------------------------------------------------+
 int pr(double n)       {    //  p=MathRound(1.0/Point);
 // int p=MathRound(1.0/Point);  1/0.01 = 100;
 return(MathRound(n*p));}    //  95.00*100=9500;
//+-------------------------------------------------------------------+
 int pt(double n)              {
   int n2=MathRound((n-MathFloor(n))*1000);    // 0.120..1  0.119..9 > 120  119
  while(true)               //    0  9
   if(n2%10<1)              // n2==*10+0
      n2/=10; else          //  0
   if(n2%10==9)             // n2==*10+9
     {n2=MathRound(n2/10);} //  9 (119 > 11.9 > 12)
   else if(n2%10>0) return(n2);}
//+-------------------------------------------------------------------+
 void teni(string ln, int i, double h, double l, color Color){
   if(ObjectFind(ln+"_"+"hi-lo"+Time[i])<0)                 {
    ObjectCreate(ln+"_"+"hi-lo"+Time[i],OBJ_TREND,x,Time[i],h,Time[i],l);
       ObjectSet(ln+"_"+"hi-lo"+Time[i],OBJPROP_COLOR, Color);
       ObjectSet(ln+"_"+"hi-lo"+Time[i],OBJPROP_RAY, false);}
    else
       ObjectSet(ln+"_"+"hi-lo"+Time[i],OBJPROP_PRICE1,h);
       ObjectSet(ln+"_"+"hi-lo"+Time[i],OBJPROP_PRICE2,l);
       ObjectSet(ln+"_"+"hi-lo"+Time[i],OBJPROP_COLOR, Color);
       ObjectSet(ln+"_"+"hi-lo"+Time[i],OBJPROP_RAY, false); }
//+-------------------------------------------------------------------+
 int iBS(int TF, datetime time)                    { //     TF ,   
   return(iBarShift(NULL,TF,(time-time%(TF*60)))); } //  iBarshift ,     